
// EX3Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "EX3.h"
#include "EX3Dlg.h"
#include "mm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CEX3Dlg dialog
CEX3Dlg::CEX3Dlg(CWnd* pParent /*=NULL*/)
: CDialog(CEX3Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	_ode = NULL;
	_ogl = NULL;

	_ctrlDlg = NULL;
}

void CEX3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CEX3Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CTRL, &CEX3Dlg::OnBnClickedButtonCtrl)
END_MESSAGE_MAP()


BOOL CEX3Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// OpenGL ׸ ȭ ũ⸦ ´.
	// ⼭ Ŭ̾Ʈ   ư ִ    ´.
	CRect rect;
	GetClientRect(rect);
	rect.top += 40;

	// ODE ü Ѵ.
	_ode = new COde ();

	//ü  
	//AddBox, AddSphere, AddCylinder ̿Ͽ ü ġ ũ  Ư¡ 
	//AttachBallJoint, AttachFixedJoint  ̿Ͽ  ü Joint

	//                   name, mass, color(R,G,B), 		 Position(x, y, z), Attitude(roll, pitch, yaw),		   Size(dx, dy, dz)

	// ٸ 
	_ode->AddBox		("RFOOT", 		2, 	RGB(  72,  72,  72), 		0, -0.08, 0.008,	_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.18, 0.1, 0.008); 
	_ode->AddCapsule	("RLEG", 		2, 	RGB( 192, 192, 192), 	-0.02, -0.08, 0.16,		_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.03, 0.22);
	_ode->AddCapsule	("RTHIGH", 		2, 	RGB( 192, 192, 192), 	-0.02, -0.08, 0.42,		_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.03, 0.16);
	
	// ٸ 
	_ode->AddBox		("LFOOT", 		2, 	RGB(  72,  72,  72), 		0, 0.08, 0.008,		_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.18, 0.1, 0.008);
	_ode->AddCapsule	("LLEG", 		2, 	RGB( 192, 192, 192), 	-0.02, 0.08, 0.16,		_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.03, 0.22);
	_ode->AddCapsule	("LTHIGH", 		2, 	RGB( 192, 192, 192), 	-0.02, 0.08, 0.42,		_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.03, 0.16);

	//ü 
	_ode->AddBox		("HIP", 		3, 	RGB( 127, 127, 127), 	-0.02, 0, 0.62,			_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.1, 0.2, 0.15);
	_ode->AddBox		("WAIST", 		4, 	RGB( 192, 192, 192), 	-0.02, 0, 0.84,			_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.1, 0.2, 0.28);
	_ode->AddSphere		("HEAD", 		1, 	RGB( 192, 192, 192), 	-0.02, 0, 1.05,			_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.06);
	_ode->AddSphere		("NOSE", 		1, 	RGB( 192, 192, 192), 	 0.04, 0, 1.05,			_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.01);

	//,    ڻ
	_ode->AddCapsule	("RARM", 		1, 	RGB( 192, 192, 192), 	-0.02, -0.125, 0.85,	_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.02, 0.16);
	_ode->AddCapsule	("LARM", 		1, 	RGB( 192, 192, 192), 	-0.02, 0.125, 0.85,		_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.02, 0.16);
	_ode->AddCapsule	("LELBOW", 		1, 	RGB( 192, 192, 192), 	-0.02, 0.125, 0.65,		_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.02, 0.15);
	_ode->AddCapsule	("RELBOW", 		1, 	RGB( 192, 192, 192), 	-0.02, -0.125, 0.65,	_DEG2RAD*0, _DEG2RAD*0, _DEG2RAD*0,	0.02, 0.15);

	//ٸ Joint
	_ode->AttachBallJoint	("JOINT0", "RFOOT", "RLEG", 			-0.02, -0.1, 0.008,		100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachHingeJoint	("JOINT1", "RLEG", "RTHIGH", 0, 1, 0,	-0.02, -0.1, 0.32,		100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachBallJoint	("JOINT2", "RTHIGH", "HIP", 			-0.02, -0.1, 0.57, 		100, _DEG2RAD*-180, _DEG2RAD*180);
																								 
	//޴ٸ Joint																		 
	_ode->AttachBallJoint	("JOINT3", "LFOOT", "LLEG", 			-0.02, 0.1, 0.008, 		100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachHingeJoint	("JOINT4", "LLEG", "LTHIGH", 0, 1, 0,	-0.02, 0.1, 0.32, 		100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachBallJoint	("JOINT5", "LTHIGH", "HIP", 			-0.02, 0.1, 0.57,		100, _DEG2RAD*-180, _DEG2RAD*180);
																								 
	//ü Joint																			 
	_ode->AttachBallJoint	("JOINT6", "HIP", "WAIST", 				-0.02, 0, 0.70, 		100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachBallJoint	("JOINT7", "WAIST", "HEAD", 			-0.02, 0, 0.96,			100, _DEG2RAD*-180, _DEG2RAD*180);
																								 
	//Ȱ    Joint															 
	_ode->AttachBallJoint	("JOINT10", "WAIST", "RARM",  			-0.02, -0.125, 0.94, 	100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachBallJoint	("JOINT11", "WAIST", "LARM",  			-0.02, 0.125, 0.94, 	100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachHingeJoint	("JOINT12", "RARM","RELBOW",  0, 1, 0,	-0.02, 0.125, 0.76, 	100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachHingeJoint	("JOINT13", "LARM","LELBOW",  0, 1, 0,	-0.02, -0.125, 0.76, 	100, _DEG2RAD*-180, _DEG2RAD*180);
	_ode->AttachFixedJoint	("JOINT14", "HEAD","NOSE");


	// ODE ׸  OpenGL ü Ѵ.
	_ogl = new COdeOgl(_ode, "ODE", rect, this, 90000);
	_ogl->_showAxis = true;

	SetTimer (1000, 10, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEX3Dlg::OnPaint()
{
	if (IsIconic()) 
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEX3Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CEX3Dlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	//   ũⰡ ٲ , OpenGL  ũ⸦ Ѵ.
	_ogl->MoveWindow (0, 40, cx, cy-40);
}

void CEX3Dlg::OnDestroy()
{
	CDialog::OnDestroy();

	if(_ctrlDlg) {
		_ctrlDlg->DestroyWindow ();
		delete _ctrlDlg;
	}

	_ogl->DestroyWindow ();
	delete _ogl;

	delete _ode;
}


void CEX3Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// ODE ùķ̼   Ѵ.
	_ode->Step (0.01);
	// ùķ̼  OpenGL 쿡 Ʈ Ѵ.
	_ogl->UpdateWnd ();

	CDialog::OnTimer(nIDEvent);
}

void CEX3Dlg::OnBnClickedButtonCtrl()
{
	if(_ctrlDlg != NULL) {
		_ctrlDlg->SetFocus();
		_ctrlDlg->ShowWindow(SW_SHOW);
	}
	else {
		_ctrlDlg = new CControlDlg;
		_ctrlDlg->Create(IDD_DIALOG_CONTROL, this);
		_ctrlDlg->ShowWindow(SW_SHOW);	
	}	
}
